
#include "ExpressionTree.h"
#include "MyStack.h"
#include "common.h"
#include <string.h>

/*	 Ʈ ϴ Լ Ű  ǥ ƴ  ǥ ̴.
	ȯ  Ʈ Ʈ ̴.
*/
BTreeNode* MakeExpressionTree(char exp[])
{
	MyStack Stack;
	BTreeNode* pNode = NULL;

	int expLen = strlen(exp);
	int i;

	MyStackInit(&Stack);

	for ( i = 0; i < expLen; i++)
	{
		pNode = MakeBTreeNode();

		/*	( ) ̸, ÿ 带 .	*/
		if ('1' <= exp[i] && exp[i] <= '9')
		{
			SetData(pNode, exp[i] - '0');
		}
		/*	̸, 	*/
		else
		{
			SetData(pNode, exp[i]);

			/*	ÿ  2    ڽ ϰ ٽ ÿ .	*/
			MakeRightSubTree(pNode, Top(&Stack));
			Pop(&Stack);

			MakeLeftSubTree(pNode, Top(&Stack));
			Pop(&Stack);
		}

		Push(&Stack, pNode);
	}

	/*	 ÿ   ϳ ۿ .	*/
	pNode = Top(&Stack);
	Pop(&Stack);

	return pNode;
}

/*	 Ʈ ϴ Լ	*/
int EvaluateExpressionTree(BTreeNode* pNode)
{
	int leftOp, rightOp;

	/*	ܸ  ڸ  Ƿ,  ڸ 	*/
	if (GetLeftSubTree(pNode) == NULL && GetRightSubTree(pNode) == NULL)
		return GetData(pNode);

	/*	pNode   Ʈ   Ʈ 갪 ´.	*/
	leftOp = EvaluateExpressionTree(GetLeftSubTree(pNode));
	rightOp = EvaluateExpressionTree(GetRightSubTree(pNode));

	/*	 ϰ,   Ѵ.	*/
	switch (GetData(pNode))
	{
	case '*':	return leftOp * rightOp;
	case '/':	return leftOp / rightOp;
	case '+':	return leftOp + rightOp;
	case '-':	return leftOp - rightOp;
	}
	return 0;
}

